1
0
mirror of https://git.dev.opencascade.org/repos/occt.git synced 2025-04-05 18:16:23 +03:00

0032738: Configuration, scripts - handle ABI list within iOS building script adm/scripts/ios_build.sh

Variables "toSimulator" and "anAbi" within "ios_custom.sh"
have been replaced by "anAbiList" which can be defined like "iPhoneOS|arm64 iPhoneSimulator|arm64".
Added "toPackFat" option packing multiple architectures into FAT archives.
This commit is contained in:
kgv 2021-12-17 05:50:46 +03:00 committed by smoskvin
parent 4d476dd2ed
commit 90eac74988
2 changed files with 163 additions and 97 deletions

View File

@ -20,13 +20,13 @@ export aRapidJson=
export aDraco= export aDraco=
# build stages to perform # build stages to perform
export toSimulator=0
export isStatic=1 export isStatic=1
export toCMake=1 export toCMake=1
export toClean=1 export toClean=1
export toMake=1 export toMake=1
export toInstall=1 export toInstall=1
export toPack=0 export toPack=0
export toPackFat=0
export toDebug=0 export toDebug=0
export BUILD_ModelingData=ON export BUILD_ModelingData=ON
@ -41,13 +41,25 @@ export USE_RAPIDJSON=OFF
export USE_DRACO=OFF export USE_DRACO=OFF
export IPHONEOS_DEPLOYMENT_TARGET=8.0 export IPHONEOS_DEPLOYMENT_TARGET=8.0
export anAbi=arm64 #export anAbiList="iPhoneOS|arm64 iPhoneSimulator|arm64 iPhoneSimulator|x86_64"
#export anAbi=x86_64 export anAbiList="iPhoneOS|arm64"
if [[ -f "${aScriptDir}/ios_custom.sh" ]]; then if [[ -f "${aScriptDir}/ios_custom.sh" ]]; then
source "${aScriptDir}/ios_custom.sh" source "${aScriptDir}/ios_custom.sh"
fi fi
anOcctVerSuffix=`grep -e "#define OCC_VERSION_DEVELOPMENT" "$aCasSrc/src/Standard/Standard_Version.hxx" | awk '{print $3}' | xargs`
anOcctVersion=`grep -e "#define OCC_VERSION_COMPLETE" "$aCasSrc/src/Standard/Standard_Version.hxx" | awk '{print $3}' | xargs`
aGitBranch=`git symbolic-ref --short HEAD`
YEAR=$(date +"%Y")
MONTH=$(date +"%m")
DAY=$(date +"%d")
aRevision=-${YEAR}-${MONTH}-${DAY}
#aRevision=-${aGitBranch}
set -o pipefail
aBuildType="Release" aBuildType="Release"
aBuildTypePrefix= aBuildTypePrefix=
if [[ $toDebug == 1 ]]; then if [[ $toDebug == 1 ]]; then
@ -58,59 +70,52 @@ aLibType="Shared"
if [[ $isStatic == 1 ]]; then if [[ $isStatic == 1 ]]; then
aLibType="Static" aLibType="Static"
fi fi
aPlatformAndCompiler=ios-${anAbi}${aBuildTypePrefix}-clang
aPlatformSdk="iphoneos"
aSysRoot="/Applications/Xcode.app/Contents/Developer/Platforms/iPhoneOS.platform/Developer/SDKs/iPhoneOS.sdk"
if [[ $toSimulator == 1 ]]; then
#anAbi=x86_64
aPlatformAndCompiler=ios-simulator64-${anAbi}${aBuildTypePrefix}-clang
aPlatformSdk="iphonesimulator"
aSysRoot="/Applications/Xcode.app/Contents/Developer/Platforms/iPhoneSimulator.platform/Developer/SDKs/iPhoneSimulator.sdk"
fi
aWorkDir="${aCasSrc}/${aBuildRoot}/${aPlatformAndCompiler}-make" function buildArch {
aDestDir="${aCasSrc}/${aBuildRoot}/${aPlatformAndCompiler}" anAbi=$1
aLogFile="${aCasSrc}/${aBuildRoot}/build-${aPlatformAndCompiler}.log" aPlatformSdk=$2
if [[ $toCMake == 1 ]] && [[ $toClean == 1 ]]; then aPlatformAndCompiler=${aPlatformSdk}-${anAbi}${aBuildTypePrefix}-clang
aWorkDir="${aCasSrc}/${aBuildRoot}/${aPlatformAndCompiler}-make"
aDestDir="${aCasSrc}/${aBuildRoot}/${aPlatformAndCompiler}"
aLogFile="${aCasSrc}/${aBuildRoot}/build-${aPlatformAndCompiler}.log"
if [[ $toCMake == 1 ]] && [[ $toClean == 1 ]]; then
rm -r -f "$aWorkDir" rm -r -f "$aWorkDir"
rm -r -f "$aDestDir" rm -r -f "$aDestDir"
fi fi
mkdir -p "$aWorkDir" mkdir -p "$aWorkDir"
mkdir -p "$aDestDir" mkdir -p "$aDestDir"
rm -f "$aLogFile" rm -f "$aLogFile"
anOcctVerSuffix=`grep -e "#define OCC_VERSION_DEVELOPMENT" "$aCasSrc/src/Standard/Standard_Version.hxx" | awk '{print $3}' | xargs` # include some information about OCCT into archive
anOcctVersion=`grep -e "#define OCC_VERSION_COMPLETE" "$aCasSrc/src/Standard/Standard_Version.hxx" | awk '{print $3}' | xargs` echo \<pre\>> "${aWorkDir}/VERSION.html"
aGitBranch=`git symbolic-ref --short HEAD` git status >> "${aWorkDir}/VERSION.html"
git log -n 100 >> "${aWorkDir}/VERSION.html"
echo \</pre\>>> "${aWorkDir}/VERSION.html"
# include some information about OCCT into archive pushd "$aWorkDir"
echo \<pre\>> "${aWorkDir}/VERSION.html"
git status >> "${aWorkDir}/VERSION.html"
git log -n 100 >> "${aWorkDir}/VERSION.html"
echo \</pre\>>> "${aWorkDir}/VERSION.html"
pushd "$aWorkDir" aTimeZERO=$SECONDS
aTimeZERO=$SECONDS function logDuration {
set -o pipefail
function logDuration {
if [[ $1 == 1 ]]; then if [[ $1 == 1 ]]; then
aDur=$(($4 - $3)) aDur=$(($4 - $3))
echo $2 time: $aDur sec>> "$aLogFile" echo $2 time: $aDur sec>> "$aLogFile"
fi fi
} }
# (re)generate Make files aSysRoot="/Applications/Xcode.app/Contents/Developer/Platforms/${aPlatformSdk}.platform/Developer/SDKs/${aPlatformSdk}.sdk"
if [[ $toCMake == 1 ]]; then
# (re)generate Make files
if [[ $toCMake == 1 ]]; then
echo Configuring OCCT for iOS... echo Configuring OCCT for iOS...
cmake -G "Unix Makefiles" \ cmake -G "Unix Makefiles" \
-D CMAKE_SYSTEM_NAME="iOS" \ -D CMAKE_SYSTEM_NAME="iOS" \
-D CMAKE_OSX_ARCHITECTURES:STRING="$anAbi" \ -D CMAKE_OSX_ARCHITECTURES:STRING="$anAbi" \
-D CMAKE_OSX_DEPLOYMENT_TARGET:STRING="$IPHONEOS_DEPLOYMENT_TARGET" \ -D CMAKE_OSX_DEPLOYMENT_TARGET:STRING="$IPHONEOS_DEPLOYMENT_TARGET" \
-D CMAKE_OSX_SYSROOT:PATH="$aSysRoot" \ -D CMAKE_OSX_SYSROOT:PATH="$aSysRoot" \
-D ENABLE_VISIBILITY:BOOL="TRUE" \
-D CMAKE_C_USE_RESPONSE_FILE_FOR_OBJECTS:BOOL="OFF" \ -D CMAKE_C_USE_RESPONSE_FILE_FOR_OBJECTS:BOOL="OFF" \
-D CMAKE_CXX_USE_RESPONSE_FILE_FOR_OBJECTS:BOOL="OFF" \ -D CMAKE_CXX_USE_RESPONSE_FILE_FOR_OBJECTS:BOOL="OFF" \
-D CMAKE_BUILD_TYPE:STRING="$aBuildType" \ -D CMAKE_BUILD_TYPE:STRING="$aBuildType" \
@ -147,55 +152,116 @@ if [[ $toCMake == 1 ]]; then
-D BUILD_DOC_Overview:BOOL="OFF" \ -D BUILD_DOC_Overview:BOOL="OFF" \
"$aCasSrc" 2>&1 | tee -a "$aLogFile" "$aCasSrc" 2>&1 | tee -a "$aLogFile"
aResult=$?; if [[ $aResult != 0 ]]; then exit $aResult; fi aResult=$?; if [[ $aResult != 0 ]]; then exit $aResult; fi
fi fi
aTimeGEN=$SECONDS aTimeGEN=$SECONDS
logDuration $toCMake "Generation" $aTimeZERO $aTimeGEN logDuration $toCMake "Generation" $aTimeZERO $aTimeGEN
# clean up from previous build # clean up from previous build
if [[ $toClean == 1 ]]; then if [[ $toClean == 1 ]]; then
make clean make clean
fi fi
# build the project # build the project
if [[ $toMake == 1 ]]; then if [[ $toMake == 1 ]]; then
echo Building... echo Building...
make -j $aNbJobs 2>&1 | tee -a "$aLogFile" make -j $aNbJobs 2>&1 | tee -a "$aLogFile"
aResult=$?; if [[ $aResult != 0 ]]; then exit $aResult; fi aResult=$?; if [[ $aResult != 0 ]]; then exit $aResult; fi
fi fi
aTimeBUILD=$SECONDS aTimeBUILD=$SECONDS
logDuration $toMake "Building" $aTimeGEN $aTimeBUILD logDuration $toMake "Building" $aTimeGEN $aTimeBUILD
logDuration $toMake "Total building" $aTimeZERO $aTimeBUILD logDuration $toMake "Total building" $aTimeZERO $aTimeBUILD
# install the project # install the project
if [[ $toInstall == 1 ]]; then if [[ $toInstall == 1 ]]; then
echo Installing OCCT into $aDestDir... echo Installing OCCT into $aDestDir...
make install 2>&1 | tee -a "$aLogFile" make install 2>&1 | tee -a "$aLogFile"
cp -f "$aWorkDir/VERSION.html" "$aDestDir/VERSION.html" cp -f "$aWorkDir/VERSION.html" "$aDestDir/VERSION.html"
fi echo Platform: ${aPlatformSdk} ABI: ${anAbi} Build: ${aBuildType} IPHONEOS_DEPLOYMENT_TARGET: ${IPHONEOS_DEPLOYMENT_TARGET} > "$aDestDir/build_target.txt"
aTimeINSTALL=$SECONDS fi
logDuration $toInstall "Install" $aTimeBUILD $aTimeINSTALL aTimeINSTALL=$SECONDS
logDuration $toInstall "Install" $aTimeBUILD $aTimeINSTALL
# create an archive
if [[ $toPack == 1 ]]; then
YEAR=$(date +"%Y")
MONTH=$(date +"%m")
DAY=$(date +"%d")
aRevision=-${YEAR}-${MONTH}-${DAY}
#aRevision=-${aGitBranch}
# create an archive
if [[ $toPack == 1 ]]; then
anArchName=occt-${anOcctVersion}${anOcctVerSuffix}${aRevision}-${aPlatformAndCompiler}.tar.bz2 anArchName=occt-${anOcctVersion}${anOcctVerSuffix}${aRevision}-${aPlatformAndCompiler}.tar.bz2
echo Creating an archive ${aCasSrc}/${aBuildRoot}/${anArchName}... echo Creating an archive ${aCasSrc}/${aBuildRoot}/${anArchName}...
rm ${aDestDir}/../${anArchName} &>/dev/null rm ${aDestDir}/../${anArchName} &>/dev/null
pushd "$aDestDir" pushd "$aDestDir"
tar -jcf ${aDestDir}/../${anArchName} * tar -jcf ${aDestDir}/../${anArchName} *
popd popd
fi
aTimePACK=$SECONDS
logDuration $toPack "Packing archive" $aTimeINSTALL $aTimePACK
# finished
DURATION=$(($aTimePACK - $aTimeZERO))
echo Total time: $DURATION sec
logDuration 1 "Total" $aTimeZERO $aTimePACK
popd
}
for anArchIter in $anAbiList
do
IFS="|" read -r aPlatform anArch <<< "$anArchIter"
echo Platform: ${aPlatform} ABI: ${anArch} Build: ${aBuildType}
buildArch $anArch $aPlatform
done
# create a FAT archive
if [[ $toPackFat == 1 ]]; then
for aPlatIter in iPhoneOS iPhoneSimulator
do
aSuffixFat=${aPlatIter}${aBuildTypePrefix}-clang
aFatDir="${aCasSrc}/${aBuildRoot}/${aSuffixFat}"
# merge per-arch builds into fat builds
hasPlatform=0
for anArchIter in $anAbiList
do
IFS="|" read -r aPlatform anArch <<< "$anArchIter"
if [[ $aPlatIter != ${aPlatform} ]]; then
continue
fi
aSuffixThin=${aPlatform}-${anArch}${aBuildTypePrefix}-clang
anArchDir="${aCasSrc}/${aBuildRoot}/${aSuffixThin}"
if [[ $hasPlatform == 0 ]]; then
hasPlatform=1
echo Packing FAT archive for platform: ${aPlatform}
rm -r -f "$aFatDir"
mkdir -p "$aFatDir"
rsync -r --exclude '*.a' "$anArchDir/" "$aFatDir"
rm -f "$aFatDir/build_target.txt"
for aLibIter in $anArchDir/lib/*.a; do
aLibName=`basename $aLibIter`
lipo "$anArchDir/lib/$aLibName" -output "$aFatDir/lib/$aLibName" -create
done
else
for aLibIter in $aFatDir/lib/*.a; do
aLibName=`basename $aLibIter`
lipo "$aFatDir/lib/$aLibName" "$anArchDir/lib/$aLibName" -output "$aFatDir/lib/$aLibName" -create
#lipo -info "$aFatDir/lib/$aLibName"
done
fi
cat "$anArchDir/build_target.txt" >> "$aFatDir/build_target.txt"
done
# create an archive
for anArchIter in $anAbiList
do
IFS="|" read -r aPlatform anArch <<< "$anArchIter"
if [[ $aPlatIter != ${aPlatform} ]]; then
continue
fi
anArchName=occt-${anOcctVersion}${anOcctVerSuffix}${aRevision}-${aSuffixFat}.tar.bz2
echo Creating an archive ${aCasSrc}/${aBuildRoot}/${anArchName}...
rm ${aFatDir}/../${anArchName} &>/dev/null
pushd "$aFatDir"
tar -jcf ${aFatDir}/../${anArchName} *
popd
break
done
done
fi fi
aTimePACK=$SECONDS
logDuration $toPack "Packing archive" $aTimeINSTALL $aTimePACK
# finished
DURATION=$(($aTimePACK - $aTimeZERO))
echo Total time: $DURATION sec
logDuration 1 "Total" $aTimeZERO $aTimePACK
popd

View File

@ -1,4 +1,4 @@
# environment configuration template for macos_build.sh (to be renamed as macos_custom_env.sh) # environment configuration template for ios_build.sh (to be renamed as ios_custom_env.sh)
export PATH=/Applications/CMake.app/Contents/bin:$PATH export PATH=/Applications/CMake.app/Contents/bin:$PATH
export aFreeType="$aSrcRoot/../3rdparty/freetype-2.10.4-ios" export aFreeType="$aSrcRoot/../3rdparty/freetype-2.10.4-ios"
export aFreeImage="$aSrcRoot/../3rdparty/freeimage-3.18-ios" export aFreeImage="$aSrcRoot/../3rdparty/freeimage-3.18-ios"
@ -6,13 +6,13 @@ export aRapidJson="$aSrcRoot/../3rdparty/rapidjson-1.1.0"
export aDraco="$aSrcRoot/../3rdparty/draco-1.4.1-ios" export aDraco="$aSrcRoot/../3rdparty/draco-1.4.1-ios"
# Uncomment to customize building steps # Uncomment to customize building steps
#export toSimulator=0
#export isStatic=0 #export isStatic=0
#export toCMake=1 #export toCMake=1
#export toClean=1 #export toClean=1
#export toMake=1 #export toMake=1
#export toInstall=1 #export toInstall=1
#export toPack=0 #export toPack=0
#export toPackFat=1
#export toDebug=0 #export toDebug=0
#export BUILD_ModelingData=ON #export BUILD_ModelingData=ON
@ -26,5 +26,5 @@ export aDraco="$aSrcRoot/../3rdparty/draco-1.4.1-ios"
#export USE_FREEIMAGE=ON #export USE_FREEIMAGE=ON
#export IPHONEOS_DEPLOYMENT_TARGET=8.0 #export IPHONEOS_DEPLOYMENT_TARGET=8.0
#export anAbi=arm64 #export anAbiList="iPhoneOS|arm64 iPhoneSimulator|arm64 iPhoneSimulator|x86_64"
#export anAbi=x86_64 #export anAbiList="iPhoneOS|arm64"